c	implicit real*8 (A-H,O-Z)
	parameter (iim=450,jjm=190,km=55)
	parameter (pi=3.141592654)
	DIMENSION H(iim,jjm),EN(iim,jjm,km),c(iim,iim),AK(iim,jjm)
     &	,CG(iim,jjm),a(iim,jjm,km),AKK(iim,jjm),delta(iim,jjm)
     & ,CGX(iim,jjm),CGY(iim,jjm),E(iim,jjm,km),He(iim,jjm,km),
     & cth(iim,jjm,km),Hes(iim,jjm),icod(iim,jjm),Hedm(iim,jjm),
     & enp(iim,jjm,km), Qb(iim,jjm), Hesd(iim,jjm),ze(iim,jjm)
	 

c       Ao is the angle of incidence in DEG
c       positive from 'SW'
	DATA HO,DT,DX/1.,.005,20./
       DATA tend,HOO,Ao,slope/200.,10.,-45.,40./ 
       DATA GAMMA,nrn,per/.55,10,6./
	dmin=.25*HO
	dmin=.25
	dhr=-HO
	
	NM=int(tend/dt)
	open (unit=3, file='depth.dat')
	read(3,*) im,jm
	do j=1,jm
	read(3,*) jj
	write (*,*) j,jj
	read(3,*) (H(i,j), i=1,im)
	end do

	OPEN(13,FILE='icod.dat')

      DO 200 J=1,JM
      read (13,*) ija

      READ(13,*)(icod(I,J),I=1,IM)	   

200    continue
      CLOSE(13)

	
	do j=1,jm
	write (*,*) j,H(im/2,j)
	end do

c    Tuning parameters
	gkapa=2.5 
	anb=0.5
	wf=.0025
	ism=6
c	wf=0.
	kmx=53

	da=2.*pi/(kmx-1)
	da=pi/(kmx-1)

	Ao=Ao*pi/180.
	write(*,*) ao
	kin=nint((Ao+pi/2.)/da)+1
	
	write (*,*) 'k-angle', kin	
      
	do i=1,im
	do j=1,jm
	a(i,j,1)=-pi/2.
	end do
	end do


	do i=1,im
	do j=1,jm
	do k=2,kmx
	a(i,j,k)=a(i,j,k-1)+da
	end do
	end do
	end do
	

	do k=1,kmx
c	write(*,*) k,a(im/2,1,k)
	kkn=nint((a(im/2,1,k)+pi/2.)/da)+1
	write (*,*) k,kkn,a(im/2,1,k),kin
	end do


C      AK=SQRT(A1OO**2+A2OO**2)*HOO
C      TANH=(EXP(AK)-EXP(-AK))/(EXP(AK)+EXP(-AK))
C      SGO=SQRT(9.81*AK/HOO*TANH)

c       DO i=1,iM
c       H(i,1)=HOO
c       end do

c	OPEN(16,FILE='vel.dat')
c	do j=1,JM
c	do i=1,IM

c	read (16,*) ai,aj,Uc,Vc,ze(i,j)

c	end do
c	end do
c	close (16)   
	
	DO J=1,JM
      DO I=1,IM
	if (H(I,J).lt.dhr)  icod(i,j)=1
c	H(i,j)=H(i,j)+ze(i,j)
	if (H(I,J).lt.dmin)  H(i,j)=dmin
	end do
      end do


c	DO J=1,JM
c      DO I=1,IM
c      if (H(I,J).lt..01)  then
c	icod(i,j)=1
c	else
c	end if
c	end do
c     end do

	do k=1,kmx
      DO J=1,JM
      DO I=1,IM
      He(i,j,k)=Ho/40.
	en(i,j,k)=9.81*(He(i,j,k)**2)/8.
      end do
      end do
	end do



     

	ALo=9.81*(PER**2)/(2*3.14)
	ALNGHP=ALo

	DO I=1,IM
		do j=1,jm
	if (h(i,j).gt..8*dmin) then
	SIGMA=2*3.14/PER
	PSI=(SIGMA**2)*h (I,j)/9.81
	HLHUNT=1+.6522*PSI+.4622*(PSI**2)+.0864*(PSI**4)+.0675*PSI**5
	HUNT=1.0/(PSI+1.0/HLHUNT)
	ALNGH=PER*SQRT(9.81*h(I,j))*SQRT(HUNT)

   39   AKAPA=2*3.14/ALNGHP
	AKD=AKAPA*h(I,j)
	ALNGH=ALo*TANH(AKD)
	DLEN=ABS(ALNGH-ALNGHP)
	IF (DLEN.GT.0.001) THEN
	ALNGHP=ALNGH
	GOTO 39
	ELSE
	END IF
	CEL=ALNGH/PER
	AN=0.5*(1.+2.*AKD/SINH(2.*AKD))
	CG(I,j)=AN*CEL
	c(i,j)=cel
	akk(I,j)=2*3.14/ALNGH
	ak(I,j)=2*3.14/ALNGH
	else
	ALNGH=sqrt(9.81*H(i,j))*per
	akk(I,j)=2*3.14/ALNGH
	ak(I,j)=2*3.14/ALNGH
	end if
	END DO

		end do


        write (*,*) 'OK'

       N=0
  100  N=N+1
	T=T+DT
c	write(*,*) t

c     kathorizei KAI tin gonia proptosis
c     gia k=(kmx+1)/2 egarsia
c     gai k=... plagia
	DO I=1,IM
	if (icod(i,j).eq.0) then
	He(i,1,kin)=HO
	EN(i,1,kin)=9.81*(He(i,1,kin)**2.)/8.
	ENp(i,1,kin)=9.81*(He(i,1,kin)**2.)/8.
	else
	end if
	END DO

	
	do jjj=1,ism
	DO I=2,IM-1
	DO J=2,JM-1
	Hesd(i,j)=0.2*Hes(i,j)+0.2*Hes(i+1,j)+0.2*Hes(i-1,j)+
     & +0.2*Hes(i,j+1)+0.2*Hes(i,j-1)         
	END DO
	END DO

	end do


	do k=2,kmx
	
c	DO I=1,IM 
c	DO J=1,JM
c	He(I,j,k)=sqrt(8.*abs(E(i,j,k))/9.81)
c	end do
c	end do
c	do jjj=1,ism
c	DO I=2,IM-1
c	DO J=2,JM-1
c	He(i,j,k)=.2*He(i,j,k)+0.2*He(i+1,j,k)+0.2*He(i-1,j,k)+
c     & +0.2*He(i,j+1,k)+0.2*He(i,j-1,k)         
c	END DO
c	END DO
c	end do
c	 DO  J=2,JM-1
c      DO  I=2,IM-1
c       if (He(i,j,k).gt.(Ho/100.)) then
c       Hexx=(He(I+1,J,k)-2*He(I,J,k)+He(I-1,J,k))/DX**2
c       Heyy=(He(I,J+1,k)-2*He(I,J,k)+He(I,J-1,k))/DX**2
c       Hex=(He(i+1,j,k)-He(i-1,j,k))/2./dx
c       Hey=(He(i,j+1,k)-He(i,j-1,k))/2./dx
c       celx=(c(i+1,j)*cg(i+1,j)-c(i-1,j)*cg(i-1,j))/2./dx
c       cely=(c(i,j+1)*cg(i,j+1)-c(i,j-1)*cg(i,j-1))/2./dx
c       cc=(Hex*celx+Hey*cely)/c(i,j)/cg(i,j)
c       Heit=(Hexx+Heyy+cc)/He(I,J,k)
c	else
c	Heit=0.0
c	end if
c	ypp=akk(i,j)**2+abs(Heit)
c	AK(I,J)=SQRT(ypp)
c       end do
c       end do


	DO  J=2,JM-1
c	write (*,*) j
      DO  I=2,IM-1
       if (Hesd(i,j).gt.Ho/1000.) then
       Hexx=(Hesd(I+1,J)-2*Hesd(I,J)+Hesd(I-1,J))/DX**2
       Heyy=(Hesd(I,J+1)-2*Hesd(I,J)+Hesd(I,J-1))/DX**2
       Hex=(Hesd(i+1,j)-Hesd(i-1,j))/2./dx
       Hey=(Hesd(i,j+1)-Hesd(i,j-1))/2./dx
       celx=(c(i+1,j)*cg(i+1,j)-c(i-1,j)*cg(i-1,j))/2./dx
       cely=(c(i,j+1)*cg(i,j+1)-c(i,j-1)*cg(i,j-1))/2./dx
       cc=(Hex*celx+Hey*cely)/c(i,j)/cg(i,j)
       Heit=(Hexx+Heyy+cc)/Hes(I,J)
	else
	Heit=0.0
	end if
	ypp=akk(i,j)**2+abs(Heit)
	AK(I,J)=SQRT(ypp)
       end do
       end do

	DO  J=2,JM-1
      DO  I=2,IM-1
	delta(i,j)=(ak(i,j)/akk(i,j))**2-1
	if (delta(i,j).lt.-1.) delta(i,j)=-1.
c	if (delta(i,j).gt.2.) delta(i,j)=2.
	if (icod(i,j).eq.0.and.icod(i,j-1).eq.1) delta(i,j)=delta(i,j+1)
	if (icod(i,j).eq.0.and.icod(i-1,j).eq.1) delta(i,j)=delta(i+1,j)
	if (icod(i,j).eq.0.and.icod(i+1,j).eq.1) delta(i,j)=delta(i-1,j)
	end do
	end do	



	DO  J=2,JM-1
      DO  I=2,IM-1
	cx=(c(i+1,j)-c(i-1,j))/dx/2.
	cy=(c(i,j+1)-c(i,j-1))/dx/2.
	dlt=sqrt(1.+delta(i,j))
	cth1=-dlt*cg(i,j)*(cos(a(i,j,k))*cx-sin(a(i,j,k))*cy)
     &	/c(i,j)
	delx=(delta(i+1,j)-delta(i-1,j))/2./dx
	dely=(delta(i,j+1)-delta(i,j-1))/2./dx
	cth2=cg(i,j)*(-cos(a(i,j,k))*delx+sin(a(i,j,k))*dely)/2./dlt
	cth(i,j,k)=cth1+cth2

	if (icod(i,j).eq.0.and.icod(i,j-1).eq.1.and.icod(i+1,j-1).eq.1
     &	.and.icod(i-1,j-1).eq.0) then
	cth(i,j,k)=cth(i,j,k)
	else
	end if

	if (icod(i,j).eq.0.and.icod(i,j-1).eq.1.and.icod(i+1,j-1).eq.0
     &	.and.icod(i-1,j-1).eq.1) then
	cth(i,j,k)=cth(i,j,k)
	else
	end if

	end do
	end do	

	DO 60 J=1,JM
       DO 60 I=1,IM
	dlt=sqrt(1.+delta(i,j))
	CGX(I,J)=CG(I,J)*sin(a(i,j,k))*dlt
	CGY(I,J)=CG(I,J)*cos(a(i,j,k))*dlt
60     continue
	

		do i=1,im
	do j=1,jm
	DM=H(I,J)
	Eref=9.81*(DM**2)/8.
	EE=9.81*(Hes(i,j)**2)/8.
	Qb(i,j)=(1.-EXP(-(EE/Eref/GAMMA**2.)**nrn))
	if (Qb(i,j).gt.1.25) Qb(i,j)=1.25
	if (Qb(i,j).lt.0.) Qb(i,j)=0.
	end do
	end do

	DO I=2,IM-1 
	DO J=2,JM-1
	DIS=Qb(i,j)*2.*E(I,J,k)/PER
c	DIS=(1.-EXP(-(E(I,J,k)/Eref/GAMMA**2.)**nrn))*2.*Eref/PER
	EX=(CGX(I+1,J)*E(I+1,J,k)-CGX(I-1,J)*E(I-1,J,k))/DX/2.
	tm1=cgx(i+1,j)*(-e(i+2,j,k)+9*e(i+1,j,k)+9*e(i,j,k)-e(i-1,j,k))
	tm2=cgx(i,j)*(-e(i+1,j,k)+9*e(i,j,k)+9*e(i-1,j,k)-e(i-2,j,k))
	tm3=abs(cgx(i+1,j))*(e(i+2,j,k)-3*e(i+1,j,k)+3*e(i,j,k)-e(i-1,j,k))
	tm4=abs(cgx(i,j))*(e(i+1,j,k)-3*e(i,j,k)+3*e(i-1,j,k)-e(i-2,j,k))
	EX=(tm1-tm2+1.5*tm3-1.5*tm4)/16./dx

	if (cgx(i,j).gt.0) then
	EX=(CGX(I,J)*E(I,J,k)-CGX(I-1,J)*E(I-1,J,k))/DX
	else
	EX=(CGX(I+1,J)*E(I+1,J,k)-CGX(I,J)*E(I,J,k))/DX
	end if

	if (cgy(i,j).gt.0) then
	EY=(CGY(I,J)*E(I,J,k)-CGY(I,J-1)*E(I,J-1,k))/DX
	else
	EY=(CGY(I,J+1)*E(I,J+1,k)-CGY(I,J)*E(I,J,k))/DX
	end if 

	ccy=(c(i+1,j)*cg(i+1,j)*cos(-a(i+1,j,k))**2-
     !	c(i-1,j)*cg(i-1,j)*cos(-a(i-1,j,k))**2)/dx/2.

	dey=(e(i+1,j,k)-e(i-1,j,k))/dx/2.
	deyy=c(i,j)*cg(i,j)*cos(-a(i,j,k))**2*
     !	(e(i+1,j,k)-2*e(i,j,k)+e(i-1,j,k))/dx**2


	sdlt=ak(i,j)/akk(i,j)

	disp=gkapa*(ccy*dey+.5*deyy)/2./SIGMA
	disp=0.

	cx=(c(i+1,j)-c(i-1,j))/dx/2.
	cy=(c(i,j+1)-c(i,j-1))/dx/2.
	
	if (k.eq.1.or.k.eq.kmx) then
	et=0.
	Eee=E(I,J,k)
	else
	tht2=e(i,j,k+1)*cth(i,j,k+1)
	tht0=e(i,j,k)*cth(i,j,k)
	tht1=e(i,j,k-1)*cth(i,j,k-1)
	et=((1-anb)*tht2-(1+anb)*tht1+2.*anb*tht0)/da/2.
	Eee=(1-2.*wf)*E(I,J,k)+wf*E(i,j,k-1)+wf*E(i,j,k+1)
c	Eee=E(I,J,k)
	end if

	if (k.eq.1.or.k.eq.kmx) then
	et=0.
	else
      if (cth(i,j,k).gt.0) then
	et=(0.75*e(i,j,k)*cth(i,j,k)+.25*e(i,j,k+1)*cth(i,j,k+1)-
     &    0.75*e(i,j,k-1)*cth(i,j,k-1)-.25*e(i,j,k)*cth(i,j,k))/da
	else
	et=(0.75*e(i,j,k+1)*cth(i,j,k+1)+.25*e(i,j,k)*cth(i,j,k)-
     &    0.75*e(i,j,k)*cth(i,j,k)-.25*e(i,j,k-1)*cth(i,j,k-1))/da
	end if
	end if


	EN(I,J,k)=Eee-DT*EX-DT*EY-dt*et-DT*DIS+dt*disp
	END DO
	END DO 

	DO J=1,JM
	EN(1,J,k)=EN(2,J,k)
c	EN(1,J,k)=0.
	END DO


	DO J=1,JM
	EN(im,J,k)=EN(im-1,J,k)
c	EN(im,J,k)=0.
	END DO

	do i=1,im
	EN(i,jm,k)=EN(i,jm-1,k)
	EN(i,jm,k)=0.
	end do

	do i=1,im
	do j=1,jm
	if (icod(i,j).eq.1) EN(i,j,k)=0.
	end do
	end do
	



430	DO I=2,IM-1 
	DO J=2,JM-1
	DIS=Qb(i,j)*2.*en(I,J,k)/PER
c	DIS=(1.-EXP(-(E(I,J,k)/Eref/GAMMA**2.)**nrn))*2.*Eref/PER
	EX=(CGX(I+1,J)*en(I+1,J,k)-CGX(I-1,J)*enp(I-1,J,k))/DX/2.
	tm1=cgx(i+1,j)*(-en(i+2,j,k)+9*en(i+1,j,k)+9*en(i,j,k)-enp(i-1,j,k))
	tm2=cgx(i,j)*(-en(i+1,j,k)+9*en(i,j,k)+9*enp(i-1,j,k)-enp(i-2,j,k))
	tm3=abs(cgx(i+1,j))*(en(i+2,j,k)-
     & 3*en(i+1,j,k)+3*en(i,j,k)-enp(i-1,j,k))
	tm4=abs(cgx(i,j))*(en(i+1,j,k)-3*en(i,j,k)+3*enp(i-1,j,k)-enp(i-2,j,k))
	EX=(tm1-tm2+1.5*tm3-1.5*tm4)/16./dx

	if (cgx(i,j).gt.0) then
	EX=(CGX(I,J)*en(I,J,k)-CGX(I-1,J)*enp(I-1,J,k))/DX
	else
	EX=(CGX(I+1,J)*en(I+1,J,k)-CGX(I,J)*en(I,J,k))/DX
	end if

	if (cgy(i,j).gt.0) then
	EY=(CGY(I,J)*en(I,J,k)-CGY(I,J-1)*enp(I,J-1,k))/DX
	else
	EY=(CGY(I,J+1)*en(I,J+1,k)-CGY(I,J)*en(I,J,k))/DX
	end if 

c	ccy=(c(i+1,j)*cg(i+1,j)*cos(-a(i+1,j,k))**2-
c     !	c(i-1,j)*cg(i-1,j)*cos(-a(i-1,j,k))**2)/dx/2.
c	dey=(en(i+1,j,k)-en(i-1,j,k))/dx/2.
c	deyy=c(i,j)*cg(i,j)*cos(-a(i,j,k))**2*
c     !	(en(i+1,j,k)-2*en(i,j,k)+en(i-1,j,k))/dx**2
c	disp=gkapa*(ccy*dey+.5*deyy)/2./SIGMA
	disp=0.

	cx=(c(i+1,j)-c(i-1,j))/dx/2.
	cy=(c(i,j+1)-c(i,j-1))/dx/2.
	
	if (k.eq.1.or.k.eq.kmx) then
	et=0.
	Eee=en(I,J,k)
	else
	tht2=en(i,j,k+1)*cth(i,j,k+1)
	tht0=en(i,j,k)*cth(i,j,k)
	tht1=enp(i,j,k-1)*cth(i,j,k-1)
	et=((1-anb)*tht2-(1+anb)*tht1+2.*anb*tht0)/da/2.
	Eee=(1-2.*wf)*en(I,J,k)+wf*enp(i,j,k-1)+wf*en(i,j,k+1)
c	Eee=en(I,J,k)
	end if

	if (k.eq.1.or.k.eq.kmx) then
	et=0.
	else
      if (cth(i,j,k).gt.0) then
	et=(0.75*en(i,j,k)*cth(i,j,k)+.25*en(i,j,k+1)*cth(i,j,k+1)-
     &    0.75*enp(i,j,k-1)*cth(i,j,k-1)-.25*en(i,j,k)*cth(i,j,k))/da
	else
	et=(0.75*en(i,j,k+1)*cth(i,j,k+1)+.25*en(i,j,k)*cth(i,j,k)-
     &    0.75*en(i,j,k)*cth(i,j,k)-.25*enp(i,j,k-1)*cth(i,j,k-1))/da
	end if
	end if

	ENp(I,J,k)=Eee-DT*EX-DT*EY-dt*et-DT*DIS+dt*disp
	END DO
	END DO 

	DO J=1,JM
	ENp(1,J,k)=ENp(2,J,k)
c	ENp(1,J,k)=0.
	END DO


	DO J=1,JM
	enp(im,J,k)=enp(im-1,J,k)
c	enp(im,J,k)=0.
	END DO

	do i=1,im
	enp(i,jm,k)=enp(i,jm-1,k)
	enp(i,jm,k)=0.
	end do

	do i=1,im
	do j=1,jm
	if (icod(i,j).eq.1) enp(i,j,k)=0.
	end do
	end do


	de=0.
	dee=0.
	
	DO I=1,IM
	do j=1,jm
	if (icod(i,j).eq.0) then
      De=De+ABS(en(I,j,k)-enp(I,j,k))
	Dee=Dee+ABS(enp(I,j,k))
	else
c	de=0.
	end if
	
      END DO
	end do

c	write(*,*) de,dee

	if (dee.lt..0001) dee=1.

      DeL=De/Dee
        
	IF (DeL.GE.0.001) THEN
c	write(*,*) iter
	ITER=ITER+1
	       GOTO 300
	       ELSE
	       GOTO 350
	       ENDIF
300     continue

c        IF (ITER.GT.250) GOTO 350

         
	DO I=1,IM
	do j=1,jm
	eN(I,j,k)=eNP(I,j,k)
	END DO
	end do
	GOTO 430

350    CONTINUE



	DO I=1,IM
	DO J=1,JM
	He(I,j,k)=sqrt(8.*abs(ENp(i,j,k))/9.81)
	END DO
	END DO
	
	end do

	
	DO I=1,IM
      DO J=1,JM
	Hese=0.
	do k=1,kmx
	Hese=Hese+He(i,j,k)**2
	end do 
	Hes(i,j)=sqrt(Hese)
	end do
	end do

	
	do k=1,kmx
       DO 420 I=1,IM
       DO 420 J=1,JM
       E(i,j,k)=ENp(i,j,k)
 420   CONTINUE
	end do

	WRITE (*,*) T, iter
	iter=0

       IF(N.LT.NM) GOTO 100

       OPEN(14,FILE='WN.DAT')
	OPEN(12,FILE='height.DAT')


      DO I=1,IM
      DO J=1,JM
	
	aa=0
	
	do k=1,kmx
	aa=aa+a(i,j,k)*He(i,j,k)**2
	end do
	aa=aa/Hes(i,j)**2

	WRITE(14,212) I*dx,j*dx,
     &	Hes(i,j)*sin(aa),Hes(i,j)*COS(aa)

	 

	WRITE(12,212) i*dx,j*dx,Hes(i,j),-H(I,J),aa,Qb(i,j)
	end do
    	end do


	open (15,FILE='sect_He.DAT')
	do j=1,jm
	WRITE(15,212) (88-j)*dx,1.41*Hes(im/2,j),-H(Im/2,J),Qb(im/2,j)
	end do

       
       
212    FORMAT (6F12.4)
       CLOSE(12)

       STOP
       END 
	
