      parameter (IMM=1700,JMM=800)
      DIMENSION H(imm,JMM),U(IMM,JMM),UN(IMM,JMM),V(IMM,JMM),VN(IMM,JMM)
     & ,Z(IMM,JMM),UB(IMM,JMM),VB(IMM,JMM),r(6500),VP2(6500),
     &  VP3(6500),ZP2(6500),ZP3(6500),zn(IMM,JMM),rz(6500),UP2(6500)
     & ,UP3(6500),icodsb(imm,jmm)
	dimension dsx(imm,jmm),dsy(imm,jmm), He(imm,jmm),icod(imm,jmm)
      DIMENSION sxx(imm,JMM),syy(imm,JMM),sxy(imm,JMM),umax(imm,jmm)
     & ,vmax(imm,jmm),ed(imm,jmm), thita(imm,jmm), qb(imm,jmm)
     &, c(imm,jmm), a(imm,jmm), fw(imm,jmm)

      data DT,DX/.00625,2.5/	     
      data NM/100000/ 	 	           	 	 	 
	data Ho,per/1.5,8./
	hx=1./10.
	aLo=9.81*per**2/2./3.14159
	gamma=.5+sqrt(Ho/aLo)
	gamma=.85+sqrt(Ho/aLo)
				 
	dtm=0.25		 	   	        	     	 
	d50=0.0002	 	     	    	     	 	       
	zo=2.5*d50/20.		   	      		    
	
	dhr=-1.*Ho
	dhs=.25*Ho
	    
	omega=2.*3.14/per 	 	     
	cb=0.004		   
	cf=0.0001
	aml=0.5*DX	 			 
	wf=0.98
	wf=1.
	zoo=.0000001
	dif0=.2*(9.81*Ho*per)**.25*Ho*sqrt(9.81*Ho)
	aka=0.02


	 do i=1,im
      do j=1,jm
	He(i,j)=0.
	r(j)=0.
	up2(j)=0
	up3(j)=0.
	u(i,j)=0.
	v(i,j)=0.
	ub(i,j)=0
	vb(i,j)=0
	zn(i,j)=0.
	un(i,j)=0.
	vn(i,j)=0.
	u(i,j)=0.
	v(i,j)=0.
	z(i,j)=0.
	zn(i,j)=0.
	un(i,j)=0.
	vn(i,j)=0.
	ub(i,j)=0.
	vb(i,j)=0.
	a(i,j)=0.
c      if (H(i,j).lt.dhs.and.H(i,j).gt.dhr) H(i,j)=dhs
c      if (H(i,j).le.dhr) icod(i,j)=1
      end do
      end do



        OPEN(12,FILE='depth.dat')
	read (12,*) im,jm

      DO 20 J=1,JM
      read (12,*) ij
      write (*,*) ij
      READ(12,*)(H(I,J),I=1,IM)
c      write(*,*)(H(I,J),I=1,IM)
20    continue
      CLOSE(12)

	OPEN(19,FILE='bottom.dat')
	OPEN(10,FILE='sxxyy.dat')

		do j=1,jm
		do i=1,im
       read (19,*) umax(i,j),vmax(i,j),ed(i,j),qb(i,j)
       read (10,*) sxx(i,j),syy(i,j),sxy(i,j)
	umax(i,j)=umax(i,j)/2.
	vmax(i,j)=vmax(i,j)/2.

		end do
		end do


	 open (unit=3,file='thita.dat')
		do j=1,jm
	read (3,*) ja
		do i=1,im
	read (3,*) ia,thita(i,j),He(i,j),c(i,j)
c	write (*,*) ia,thita(i,j),He(i,j),c(i,j)
		end do
		end do

	


		OPEN(13,FILE='icod.dat')

      DO 200 J=1,JM
      read (13,*) ija

      READ(13,*)(icod(I,J),I=1,IM)	   

200    continue
      CLOSE(13)


	OPEN(13,FILE='icodsb.dat')

      DO 202 J=1,JM
      read (13,*) ija

      READ(13,*)(icodsb(I,J),I=1,IM)	   

202    continue
      CLOSE(13)

		do ik=1,2
		do j=3,jm-2
		do i=3,im-2
		thita(i,j)=.25*thita(i-1,j)+.25*thita(i+1,j)
     & +.25*thita(i,j-1)+.25*thita(i,j+1)
		end do
		end do
	end do 

	
	
	do j=2,jm-1
	do i=2,im-1
	a(i,j)=.9*He(i,j)**2
	end do
	end do

	
	do j=2,jm-1
	do i=2,im-1
	hh=h(i,j)
	if (hh.lt.dhs) hh=dhs
	alf=thita(i,j)
	alf1=thita(i,j-1)
	al=c(i,j)*per
	al1=c(i,j-1)*per
	akd=hh*2.*3.1416/al
	akd1=hh*2.*3.1416/al1
		
	an=0.5*(1+2.*akd/sinh(2*akd))
	an1=0.5*(1+2.*akd1/sinh(2*akd1))
	cg=c(i,j)*an
	cg1=c(i,j-1)*an1
	
	sb=abs(H(i,j+1)-H(i,j-1))/2./dx
	if (sb.lt..005) sb=.005

	ror=1000.
	bitac=1.
	bitad=.1+sb
	par=cos(alf)*ror*bitac**2*c(i,j)**2/2./per+ror*9.81*bitad*dx/per
	DE=cg*cos(alf)*9.81*(He(i,j)**2)/8.
     &	-cg1*cos(alf1)*9.81*(He(i,j-1)**2)/8.
      DE=-dx*Qb(i,j)*2.*(9.81*(He(i,j)**2)/8.)/per
	hd=H(i,j)
	if (hd.lt.0.001) hd=.001
	
	alf=2.*.333*sb*per*sqrt(9.81/hd)
c	alf=.0125*sqrt(Ho)*per/sqrt(hd)/sqrt(sb)
	if (alf.lt.1.) alf=1.
c	DE=DE*alf
	par1=cos(alf1)*ror*bitac**2*c(i,j-1)**2/2./per
	par2=ror*9.81*bitad*dx/per
c	a(i,j)=(par1*a(i,j-1)-1000.*DE-par2*a(i,j-1))/par
	a(i,j)=qb(i,j)*.9*He(i,j)**2
	Er=ror*bitac*c(i,j)*abs(a(i,j))/per/2.


	rxx=2.*Er*sin(alf)**2
	ryy=2.*Er*cos(alf)**2
	rxy=Er*sin(2.*alf)
	rxx=0.
	ryy=0.
	rxy=0.

	sxx(i,j)=sxx(i,j)+rxx
	syy(i,j)=syy(i,j)+ryy
	sxy(i,j)=sxy(i,j)+rxy

	end do
	end do
	
	

	do ik=1,0
		do j=3,jm-2
		do i=3,im-2
	sxx(i,j)=.5*sxx(i,j)+
     &.125*sxx(i-1,j)+.125*sxx(i+1,j)+.125*sxx(i,j-1)+.125*sxx(i,j+1)
	syy(i,j)=.5*syy(i,j)+
     &.125*syy(i-1,j)+.125*syy(i+1,j)+.125*syy(i,j-1)+.125*syy(i,j+1)
	sxy(i,j)=.5*sxy(i,j)+
     &.125*sxy(i-1,j)+.125*sxy(i+1,j)+.125*sxy(i,j-1)+.125*sxy(i,j+1)
		
		end do
		end do
	end do 
	 					 

c	do j=1,jm
c	alf=thita(im/2,j)
c	write (*,*) j*dx,a(im/2,j), .9*He(im/2,j)**2
c	end do
c	stop



c       do i=2,im,2
c       do j=2,jm,2
c       i2=i/2				 
c       j2=j/2
c       H(i2,j2)=H(i,j)	  
c	He(i2,j2)=He(i,j)
c       ed(i2,j2)=ed(i,j)
c       sxx(i2,j2)=sxx(i,j)
c       syy(i2,j2)=syy(i,j)		   				 
c       sxy(i2,j2)=sxy(i,j)
c       umax(i2,j2)=umax(i,j)
c       vmax(i2,j2)=vmax(i,j)
c	icod(i2,j2)=icod(i,j)
c       end do
c       end do
c       do j=2,jm,2
c       j2=j/2
cc       vbn(j2)=vbn(j)
c       end do
c       dx=2.*dx
c       im=im/2
c       jm=jm/2


        do i=2,im-1
        do j=20,jm-1
c        sxx(i,j)=.6*sxx(i,j)+.1*sxx(i-1,j)+.1*sxx(i+1,j)+
c     &  .1*sxx(i,j-1)+.1*sxx(i,j+1)
c        syy(i,j)=.6*syy(i,j)+.1*syy(i-1,j)+.1*syy(i+1,j)+
c     &  .1*syy(i,j-1)+.1*syy(i,j+1)
c        sxy(i,j)=.6*sxy(i,j)+.1*sxy(i-1,j)+.1*sxy(i+1,j)+
c     &  .1*sxy(i,j-1)+.1*sxy(i,j+1)
        end do
        end do

	do i=2,im-1
        do j=20,jm-1
c        sxx(i,j)=.6*sxx(i,j)+.1*sxx(i-1,j)+.1*sxx(i+1,j)+
c     &  .1*sxx(i,j-1)+.1*sxx(i,j+1)
c        syy(i,j)=.6*syy(i,j)+.1*syy(i-1,j)+.1*syy(i+1,j)+
c     &  .1*syy(i,j-1)+.1*syy(i,j+1)
c        sxy(i,j)=.6*sxy(i,j)+.1*sxy(i-1,j)+.1*sxy(i+1,j)+
c     &  .1*sxy(i,j-1)+.1*sxy(i,j+1)
        end do
        end do

				

	do j=1,jm
	write (*,*) i,H(im/2,j),H(im/2+10,j)
	end do

	DO J=1,JM
	 DO I=1,IM

	am=(SQRT(umax(i,j)**2+vmax(i,j)**2))/omega
	if (am.gt..00001) then
	f25=exp(5.213*(2.5*d50/am)**.194-6.)
	th25=.5*f25*(am*omega)**2./(1.6*9.81*d50)
	if (th25.gt..05) then
c       ra=2.5*d50
	ra=70.*sqrt(th25-0.05)*d50
	ra=2.5*d50
	fwe=exp(5.213*(ra/am)**.194-6.)
	else
	ra=2.5*d50
	fwe=exp(5.213*(ra/am)**.194-6.)
	end if
	
	else
	end if

	
	if (fwe.lt.0.001) fwe=0.001
	if (fwe.gt.0.03) fwe=0.03
c	write(*,*) fwe
	fw(i,j)=fwe


	end do
	end do


      N=0
      T=0
  100 N=N+1
      T=T+DT


         DO 30 J=2,JM-2
	 DO 30 I=2,IM-2

	if (icod(i,j).eq.0.and.icod(i+1,j).eq.1) then
	zn(i,j)=zn(i-1,j)
	goto 30
	else
	end if
	if (icod(i,j).eq.0.and.icod(i-1,j).eq.1) then
	zn(i,j)=zn(i+1,j)
	goto 30
	else
	end if
	if (icod(i,j).eq.0.and.icod(i,j+1).eq.1) then
	zn(i,j)=zn(i,j-1)
	goto 30
	else
	end if
	if (icod(i,j).eq.0.and.icod(i,j-1).eq.1) then
	zn(i,j)=zn(i,j+1)
	goto 30
	else
	end if

c      HC=H(I,J)+z(i,j)
c      H2=H(I+1,J)+z(i+1,j)
c      H4=H(I,J+1)+z(i,j+1)
c      zn(I,J)=Z(I,J)-DT/DX*(H2*U(I+1,J)-HC*U(I,J)+H4*V(I,J+1)-HC*
c     & V(I,J))

	QR=U(I+1,J)*(H(I+1,J)+H(I,J)+z(i+1,j)+z(i,j))/2.
      QL=U(I,J)*(H(I,J)+H(I-1,J)+z(i-1,j)+z(i,j))/2.
      QO=V(I,J+1)*(H(I,J+1)+H(I,J)+z(i,j+1)+z(i,j))/2.
      QU=V(I,J)*(H(I,J)+H(I,J-1)+z(i,j-1)+z(i,j))/2.
      zN(I,J)=z(I,J)-DT/DX*(QR-QL+QO-QU)
      
	hh=zn(i,j)+h(i,j)
	IF(hh.LT.zoo) zn(I,J)=-h(i,j) 


   30 CONTINUE


	

	 DO 150 J=2,JM-1
	 DO 150 I=2,IM-1

	if (icod(i,j).eq.1) then
	un(i,j)=0.0
	goto 150
	else
	end if

	if (icod(i,j).eq.0.and.icod(i+1,j).eq.1) then
	un(i,j)=0
	goto 150
	else
	end if
	if (icod(i,j).eq.0.and.icod(i-1,j).eq.1) then
	un(i,j)=0
	goto 150
	else
	end if
	if (icod(i,j).eq.0.and.icod(i,j+1).eq.1) then
	un(i,j)=un(i,j-1)
	goto 150
	else
	end if
	if (icod(i,j).eq.0.and.icod(i,j-1).eq.1) then
	un(i,j)=un(i,j+1)
	goto 150
	else
	end if



      HM=.5*(H(I,J)+zn(i,j)+H(I-1,J)+zn(i-1,j))
      if (HM.lt.dhs) HM=dhs

      VV=(V(I,J)+V(I-1,J)+V(I,J+1)+V(I-1,J+1))/4.
	
c       CB=(.4/(aLOG(HM/zo)-1.))**2



c	uuw=(abs(U(i,j))+umax(i,j))
c	if (uuw.gt.0.0001) then
c	alfag=abs(U(i,j))/uuw
c	else
c	alfag=1.
c	end if
	aks=2.5*d50
        cz=18.*log10(12.*HM/aks)
	fc=2.*9.81/cz**2
c	fcw=alfag*fc+(1.-alfag)*fw(i,j)

c	cb=fw/2.

c	af=1./((log(h(i,j)/zo))-1.)
c	tanak=.4*af*sqrt(fcw/2.)*SQRT(umax(i,j)**2+vmax(i,j)**2)
c	tanak=.4*af*sqrt(fw/2.)*SQRT(umax(i,j)**2+vmax(i,j)**2)
c	frict=U(I,J)*tanak

c        FRICT=.5*fcw*tafx/per

c         FRICT=CB*U(I,J)*SQRT(umax(i,j)**2+vmax(i,j)**2+U(I,J)**2+VV**2)
c         FRICT=CB*U(I,J)*SQRT(umax(i,j)**2+vmax(i,j)**2)
c         FRICT=CB*U(I,J)*SQRT(U(I,J)**2+VV**2)

	
c	fcw=2.*0.015*(aka/HM)**.3333333
	fcw=0.008
c	fcw=fc
c	fcw=fw(i,j)
        FRICT=.5*fcw*U(I,J)*SQRT(U(I,J)**2+VV**2)
	sigu=2.*umax(i,j)
	sigv=2.*vmax(i,j)
	sigmat=(SQRT(sigu**2+sigv**2))
c	sigmat=0.

	FRICT=.5*fcw*U(i,j)*(sigmat**2*1.16**2+U(i,j)**2)**.5

c       if (h(i,j).lt.dhs+.02) frict=U(I,J)*tanak 

c        vk=sqrt((U(I,J)**2+VV**2))
c        zm=0.64*sqrt(umax(i,j)**2+vmax(i,j)**2)
c        zk=0.5*((vk**2+zm**2+1.27*vk*umax(i,j))**.5+
c     &   (vk**2+zm**2-1.27*vk*umax(i,j))**.5)
c        if (zk.gt.0.01) then
c        FRICT=CB*U(I,J)*SQRT(zk+.405*umax(i,j)**2/zk)
c        else
c        FRICT=CB*U(I,J)*SQRT(U(I,J)**2+VV**2)
c        end if

c        uvt=sqrt(umax(i,j)**2+vmax(i,j)**2)
c        uuw=(abs(U(i,j))+uvt)
c	if (uuw.gt.0.0001) then
c	alfag=abs(U(i,j))/uuw
c	else
c	alfag=1.
c	end if
c	aks=2.5*d50
c	cz=18.*log10(12.*HM/aks)
c	fc=2.*9.81/cz**2
c        fcwx=alfag*fc+(1.-alfag)*fw

c        uvt=sqrt(umax(i,j)**2+vmax(i,j)**2)
c        vk=sqrt((U(I,J)**2+V(i,j)**2))
c        zm=0.64*uvt
c        zk=0.5*((vk**2+zm**2+1.27*vk*umax(i,j))**.5+
c     &   (vk**2+zm**2-1.27*vk*umax(i,j))**.5)
c        if (zk.gt.0.01) then
c        FRICTx=.5*fcwx*U(I,J)*SQRT(zk+.405*umax(i,j)**2/zk)
c        else
c        FRICTx=.5*fcwx*U(I,J)*SQRT(U(I,J)**2+V(i,j)**2)
c        end if

c        FRICTx=.5*fcwx*U(I,J)*SQRT(U(I,J)**2+V(i,j)**2)

	Ux=(U(I+1,J)-U(I-1,J))/2./DX
	Vy=(V(I,J+1)-V(I,J-1))/DX/2.
	Uy=(U(I,J+1)-U(I,J-1))/2./DX
	Vx=(V(I+1,J)-V(I-1,J))/DX/2.
      ustar=SQRT(ABS(FRICT))  
      ELD=6.*HM*ustar+.1
      DIFsm=(aml**2)*((Ux**2)+(Vy**2)+0.5*((Uy+Vx)**2))**.5
	eld=1.
       DIF=dif0/10.+ed(i,j)/5.
       dif=dif0

	cl=sqrt(9.81*H(i,j))
	ass=(.125*9.81*He(i,j)**2.)/cl
	edd=0.03+ed(i,j)/100.
c	dif=(ass**2)/2./edd
	dif=dif0+.5*He(i,j)*SQRT(umax(i,j)**2+vmax(i,j)**2)

c	aL=c(i,j)*per
c	akd=2.*3.1416*HM/aL
c	uvwt=9.81*He(i,j)*per/2./aL/cosh(akd)
c	dif=.3*He(i,j)*uvwt
	dif=ed(i,j)+dif0
	if (icodsb(i,j).eq.1) dif=3*ed(i,j)+dif0

	Ro=1000.

	dza=1./HM
c       dza=1/h(i,j)
	Sxxx=(Sxx(i,j)-Sxx(i-1,j))/dx
	Sxyy=(Sxy(i,j+1)+Sxy(i-1,j+1)-Sxy(i,j-1)-Sxy(i-1,j-1))/dx/4.
	dSx(i,j)=dza*(Sxxx+Sxyy)/Ro
 
	hms=h(i,j)+zn(i,j)
	if (hms.lt..001*dhs) hms=.001*dhs
	

	UUU=wf*U(I,J)+(1.-wf)/4.*(U(I+1,J)+U(I-1,J)+U(I,J+1)+U(I,J-1))
      UN(I,J)=UUU-DT*(9.81*(zn(I,J)-zn(I-1,J))/DX-CF*VV
     & +FRICT/HM-DIF*(U(I+1,J)+U(I-1,J)+U(I,J+1)+U(I,J-1)
     & -4*U(I,J))/DX**2)-dt*dSx(i,j)
     & -dt*U(i,j)*Ux-dt*VV*Uy


	hh1=H(I-1,J)+zn(i-1,j)
	hh=H(I,J)+zn(i,j)	

c	IF(hh.LT.zoo.AND.(hh1.LT.zoo)) UN(I,J)=0.
	
	 IF((hh1.LT.zoo).AND.(UN(I,J).GT.0.)) UN(I,J)=0.
      IF((hh.LT.zoo).AND.(UN(I,J).LT.0.)) UN(I,J)=0.	

  150 CONTINUE


	 

	 DO 121 J=2,JM-1
	 DO 121 I=2,IM-1

	if (icod(i,j).eq.1) then
	vn(i,j)=0.0
	goto 121
	else
	end if

	if (icod(i,j).eq.0.and.icod(i,j+1).eq.1) then
	vn(i,j)=0.
	goto 121
	else
	end if
	if (icod(i,j).eq.0.and.icod(i,j-1).eq.1) then
	vn(i,j)=0.
	goto 121
	else
	end if
	if (icod(i,j).eq.0.and.icod(i+1,j).eq.1) then
	vn(i,j)=vn(i-1,j)
	goto 121
	else
	end if
	if (icod(i,j).eq.0.and.icod(i-1,j).eq.1) then
	vn(i,j)=vn(i+1,j)
	goto 121
	else
	end if

       HM=.5*(H(I,J)+zn(i,j)+H(I,J-1)+zn(i,j-1))
      if (HM.lt.dhs) HM=dhs
      UU=(U(I,J)+U(I+1,J)+U(I,J-1)+U(I+1,J-1))/4.

c       CB=(.4/(ALOG(HM/ZO)-1.))**2


	
            
c	vvw=(abs(V(i,j))+vmax(i,j))
c	if (vvw.gt.0.0001) then
c	alfag=abs(V(i,j))/vvw
c	else
c	alfag=1.
c	end if
	aks=2.5*d50
c	aks=d50
	cz=18.*log10(12.*HM/aks)
	fc=2.*9.81/cz**2

c	fcw=alfag*fc+(1.-alfag)*fw(i,j)
	
c	cb=fw/2.

c	af=1./((log(h(i,j)/zo))-1.)
cc	tanak=.4*af*sqrt(fcw/2.)*SQRT(umax(i,j)**2+vmax(i,j)**2)
c	tanak=.4*af*sqrt(fw/2.)*SQRT(umax(i,j)**2+vmax(i,j)**2)
c	frict=V(I,J)*tanak


c        FRICT=.5*fcw*tafy/per

c        FRICT=CB*V(I,J)*SQRT(umax(i,j)**2+vmax(i,j)**2+V(I,J)**2+UU**2)
c        FRICT=CB*V(I,J)*SQRT(umax(i,j)**2+vmax(i,j)**2)        
c        FRICT=CB*V(I,J)*SQRT(V(I,J)**2+UU**2)
c
	
c	fcw=2.*0.015*(aka/HM)**.3333333
	fcw=0.008
c	fcw=fc
c	fcw=fw(i,j)
        FRICT=.5*fcw*V(I,J)*SQRT(V(I,J)**2+UU**2)
	sigu=2.*umax(i,j)
	sigv=2.*vmax(i,j)
	sigmat=(SQRT(sigu**2+sigv**2))
c	sigmat=0.
	FRICT=.5*fcw*V(i,j)*(sigmat**2*1.16**2+V(i,j)**2)**.5

	
c       if (h(i,j).lt.dhs+.02) frict=V(I,J)*tanak 


c        vk=sqrt((U(I,J)**2+VV**2))
c        zm=0.64*sqrt(umax(i,j)**2+vmax(i,j)**2)
c        zk=0.5*((vk**2+zm**2+1.27*vk*vmax(i,j))**.5+
c     &   (vk**2+zm**2-1.27*vk*vmax(i,j))**.5)
c        if (zk.gt.0.01) then
c        FRICT=CB*V(I,J)*SQRT(zk+.405*vmax(i,j)**2/zk)
c        else
c        FRICT=CB*V(I,J)*SQRT(U(I,J)**2+VV**2)
c        end if


c        uvt=sqrt(umax(i,j)**2+vmax(i,j)**2)
c
c        uuw=(abs(V(i,j))+uvt)
c	if (uuw.gt.0.0001) then
c        alfag=abs(V(i,j))/uuw
c	else
c	alfag=1.
c	end if
c	aks=2.5*d50
c	cz=18.*log10(12.*HM/aks)
c	fc=2.*9.81/cz**2
c        fcwy=alfag*fc+(1.-alfag)*fw

c        vk=sqrt((U(I,J)**2+V(i,j)**2))
c        zm=0.64*sqrt(umax(i,j)**2+vmax(i,j)**2)
c        zk=0.5*((vk**2+zm**2+1.27*vk*vmax(i,j))**.5+
c     &   (vk**2+zm**2-1.27*vk*vmax(i,j))**.5)
c        if (zk.gt.0.01) then
c        FRICTy=.5*fcwy*V(I,J)*SQRT(zk+.405*vmax(i,j)**2/zk)
c        else
c        FRICTy=.5*fcwy*V(I,J)*SQRT(U(I,J)**2+V(i,j)**2)
c        end if

c        FRICTy=.5*fcwy*V(I,J)*SQRT(U(I,J)**2+V(i,j)**2)


	Ux=(U(I+1,J)-U(I-1,J))/2./DX
	Vy=(V(I,J+1)-V(I,J-1))/DX/2.
	Uy=(U(I,J+1)-U(I,J-1))/2./DX
	Vx=(V(I+1,J)-V(I-1,J))/DX/2.
	
      ustar=SQRT(ABS(FRICT))  
      ELD=6.*HM*ustar+.1
       
	DIFsm=(aml**2)*((Ux**2)+(Vy**2)+0.5*((Uy+Vx)**2))**.5
	eld=1.
       DIF=dif0/10.+ed(i,j)/5.
	dif=dif0

	cl=sqrt(9.81*H(i,j))
	ass=(.125*9.81*He(i,j)**2.)/cl
	edd=0.03+ed(i,j)/100.
c	dif=(ass**2)/2./edd

		dif=dif0+.5*He(i,j)*SQRT(umax(i,j)**2+vmax(i,j)**2)
c	aL=c(i,j)*per
c	akd=2.*3.1416*HM/aL
c	uvwt=9.81*He(i,j)*per/2./aL/cosh(akd)
c	dif=.3*He(i,j)*uvwt

	dif=ed(i,j)+dif0
	if (icodsb(i,j).eq.1) dif=3*ed(i,j)+dif0

	Ro=1000.

	dza=1/(h(i,j)+zn(i,j))
	
	dza=1./HM

c       dza=1/h(i,j)
	Sxyx=(Sxy(i+1,j)+Sxy(i+1,j-1)-Sxy(i-1,j)-Sxy(i-1,j-1))/dx/4.
	Syyy=(Syy(i,j)-Syy(i,j-1))/dx
	dSy(i,j)=dza*(Sxyx+Syyy)/Ro
	

	hms=h(i,j)+zn(i,j)
	if (hms.lt..01*dhs) hms=.01*dhs
	

     	VVV=wf*V(I,J)+(1.-wf)/4.*(V(I+1,J)+V(I-1,J)+V(I,J+1)+V(I,J-1))
	VN(I,J)=VVV-DT*(9.81*(zn(I,J)-zn(I,J-1))/DX+FRICT/HM
     &  -DIF*(V(I,J+1)+V(I,J-1)+V(I+1,J)+V(I-1,J)-4*V(I,J))/
     & DX**2)-dt*dSy(i,j)
     & -dt*UU*Vx-dt*V(i,j)*Vy

		hh1=H(I,J-1)+zn(i,j-1)
	hh=H(I,J)+zn(i,j)	

c	IF((hh.LT.zoo).AND.(hh1.LT.zoo)) VN(I,J)=0.
	 IF((hh1.LT.zoo).AND.(VN(I,J).GT.0.)) VN(I,J)=0.
      IF((hh.LT.zoo).AND.(VN(I,J).LT.0.)) VN(I,J)=0.

  121 CONTINUE


c       boundary condition  sponge layer

c        West b. c.
350     do 165 j=1,jm
       do 165 i=30,2,-1
       ml1=i-30
       ml2=-30.0
       rm=exp((1.06**(ml1)-1.06**(ml2))*2.)
c       zn(30-i,j)=zn(50-i,j)/rm
       vn(30-i,j)=vn(30-i,j)/rm
165     un(30-i,j)=un(30-i,j)/rm



c        South b.c.
	do 665 i=1,im
	do 665 j=1,20
	ml1=j-20
	ml2=-20.0
	rm=exp((1.8**(ml1)-1.8**(ml2))*1.6)
	zn(i,j)=zn(i,j)/rm
	vn(i,j)=vn(i,j)/rm
665     un(i,j)=un(i,j)/rm
	do 675 i=1,im
	do 675 j=40,20,-1
	ml1=20-j
	ml2=-20
	rm=exp((1.8**(ml1)-1.8**(ml2))*1.6)
	zn(i,j)=zn(i,j)/rm
	vn(i,j)=vn(i,j)/rm
675     un(i,j)=un(i,j)/rm


c        North b.c.
c       jms=jm-20
c       do 667 i=1,im
c       do 667 j=jms,jm-10
c       ml1=j-jm+10
c       ml2=-10.0
c       rm=exp((1.8**(ml1)-1.8**(ml2))*1.6)
c       zn(i,j)=zn(i,j)/rm
c       vn(i,j)=vn(i,j)/rm
c667     un(i,j)=un(i,j)/rm
c       jms1=jm-10
c       do 677 i=1,im
c       do 677 j=jm,jms1,-1
c       ml1=j-jm
c       ml2=-10
c       rm=exp((1.8**(ml1)-1.8**(ml2))*1.6)
c       zn(i,j)=zn(i,j)/rm
c       vn(i,j)=vn(i,j)/rm
c677     un(i,j)=un(i,j)/rm

c        East b.c.
       do 668 j=1,jm
       do 668 i=im-30,im
       ml1=i-im
       ml2=-30.0
       rm=exp((1.06**(ml1)-1.06**(ml2))*2.)
       vn(i,j)=vn(i,j)/rm
668     un(i,j)=un(i,j)/rm


	do i=2,IM-2
	VN(i,2)=((1.-r(i))*VP2(i)+2.*r(i)*V(i,3))/(1.+r(i))
	end do
	do i=2,IM-2
	UN(i,1)=UN(i,2)
	end do
	do i=2,IM-2
	den=VN(i,3)+VP3(i)-2.*V(i,4)
	if (ABS(den).lt..00001) goto 207
	r(i)=(VP3(i)-VN(i,3))/den
	if (r(i).gt..99) r(i)=.99
	if (r(i).lt.0.) r(i)=0.0
	goto 60
  207   r(i)=0.0
  60   end do

	do i=2,IM-2
	ZN(i,2)=((1.-r(i))*ZP2(i)+2.*r(i)*Z(i,3))/(1.+r(i))
	end do
	do i=2,IM-2
	den=ZN(i,3)+ZP3(i)-2.*Z(i,4)
	if (ABS(den).lt..00001) goto 203
	rz(i)=(ZP3(i)-ZN(i,3))/den
	if (rz(i).gt..99) rz(i)=.99
	if (rz(i).lt.0.) rz(i)=0.0
	goto 603
  203   rz(i)=0.0
  603   end do

	do i=1,IM
	VP2(i)=V(i,2)
	VP3(i)=V(i,3)
	ZP2(i)=Z(i,2)
	ZP3(i)=Z(i,3)
	end do


	do j=2,jM-2
	UN(IM-1,j)=((1.-r(j))*UP2(j)+2.*r(j)*U(im-2,j))/(1.+r(j))
	end do
	do j=2,jM-2
	VN(im,j)=VN(im-1,j)
	end do
	do j=2,jM-2
	den=UN(im-2,j)+UP3(j)-2.*U(im-3,j)
	if (ABS(den).lt..00001) goto 217
	r(j)=(UP3(j)-UN(j,3))/den
	if (r(j).gt..99) r(j)=.99
       if (r(j).lt.0.) r(j)=0.0
	goto 61
  217   r(j)=0.0
   61   end do

	do J=1,JM
	UP2(J)=U(IM-1,J)
	UP3(J)=U(IM-2,J)
	end do

	do J=2,JM-2
	UN(2,J)=((1.-r(j))*UP2(j)+2.*r(j)*U(3,J))/(1.+r(j))
	end do
	do J=2,JM-2
	VN(1,J)=VN(2,J)
	end do
	do J=2,JM-2
	den=UN(3,J)+UP3(j)-2.*U(4,J)
	if (ABS(den).lt..00001) goto 227
	r(j)=(UP3(j)-UN(3,J))/den
	if (r(j).gt..99) r(j)=.99
	if (r(j).lt.0.) r(j)=0.0
	goto 62
 227    r(j)=0.0
   62   end do

	do j=1,JM
	UP2(j)=U(2,J)
	UP3(j)=U(3,J)
	end do



	 DO 400 J=1,JM
	 DO 400 I=1,IM			  
	 z(I,J)=zn(I,J)
	 V(I,J)=VN(I,J)
  400    U(I,J)=UN(I,J)      
	 EK=0
	 DO 410 I=2,IM-2
	 DO 410 J=2,JM-2
  410 EK=EK+H(I,J)*((V(I,J)+V(I,J+1))**2+(U(I,J)+U(I+1,J))**2)/8
	 WRITE(*,*)N,EK
      IF(N.LT.NM) GOTO 100

c       DO 420 J=1,JM-1
c  420 WRITE(2,*)(zn(I,J),U(I,J),V(I,J),I=1,IM-1)
	Jnst=2
      OPEN(13,FILE='vel.dat')


	do j=21,JM
	do i=1,IM
c	if (H(I,J).GT..01) THEN
	write (13,250) i*dx,j*dx,U(i,j),V(i,j),z(I,J)	  
c	ELSE
c	END IF
	end do
	end do
	close (13)

	
c	OPEN(13,FILE='sectsu.dat')

c	do j=1,jm
c	write(13,251) j*dx,z(im/2,j),z(im/2+50,j),-d(im/2,j)
c	end do

	OPEN(4,FILE='setup.dat')


	
	do i=1,IM
	do j=21,JM
c	if (H(I,J).GT..01) THEN
	write (4,250) i*dx,j*dx,z(i,j),-h(i,j)		  
c	ELSE
c	END IF
	end do
	end do


	
	open (unit=11,file='sect_u.dat')
	do j=21,jm
	write (11,*) (126-j)*dx,100*u(im/2,j),100*z(im/2,j)
	end do


      IF(N.LT.NM) GOTO 100
      CLOSE(1)
	 CLOSE(2)
250   format(5f16.5)
251   format(4f12.5)
	 END
