      parameter (IMM=1700,JMM=700)

      DIMENSION H(imm,JMM),U(IMM,JMM),V(IMM,JMM),He(IMM,JMM),ze(imm,jmm)
      DIMENSION qx(IMM,JMM),qy(IMM,JMM),Hn(IMM,JMM),c(IMM,JMM)
     &,zsm(imm,jmm),qxa(IMM,JMM),qya(IMM,JMM),qxaa(IMM,JMM),
     & qyaa(IMM,JMM), qbwy(IMM,JMM),qbwx(IMM,JMM), aqt(imm,jmm)
  
	DIMENSION qxr(IMM,JMM),qyr(IMM,JMM), dis(IMM,JMM), ed(IMM,JMM)
      dimension umax(imm,jmm),vmax(imm,jmm),zbn(imm,jmm),icodsb(imm,jmm) 
      DIMENSION Qb(imm,jmm),zb(imm,jmm),icod(imm,jmm), Hold(imm,jmm)
	DIMENSION dzsmn(imm,jmm), dzsm(imm,jmm), uwm(imm,jmm), vwm(imm,jmm)
      

	data d50,dx,per,slp/0.0002,2.5,8.,0.083/
		 data dt,iend/.05,25000/ 
c  1st run	 data dt,iend/.2,5000/  
c    2nd run 


	data Ho/1./	
	dhr=-1.*Ho  
	dhs=.25*Ho
	    		   

	pi=3.14159			  	
	qxmax=0.
	qymax=0.          
      omega=2.*pi/per	


	an=.0000012
	ala=1.6*9.81*d50**3/an**2
	c1=.055*tanh(12.*ala**(-.59)*exp(-.0004*ala))
	c2=1.06*tanh(.016*ala**(.5)*exp(-120./ala))
        wf=c1*1.6*9.81*d50**2/an+c2*sqrt(1.6*9.81*d50)
        write(*,*) 'wf=',wf

	
	 

	alo=9.81*(per**2)/2./3.14
	aksi=slp/sqrt(Ho/alo)
	gamma=0.55+0.15*aksi


       OPEN(12,FILE='depth.dat')
	read (12,*) im,jm

      DO 20 J=1,JM
      read (12,*) ija
	write(*,*) ija

      READ(12,*)(H(I,J),I=1,IM)	   

20    continue
      CLOSE(12)

	OPEN(12,FILE='untow.dat')
	
		do j=1,jm
		do i=1,im
       read (12,*) ax,bx,uwm(i,j),vwm(i,j)
       		end do
		end do

	CLOSE(12)

	

	do i=1,im
	do j=1,jm
	Hold(i,j)=h(i,j)
	end do
	end do

	OPEN(13,FILE='icod.dat')

      DO 200 J=1,JM
      read (13,*) ija

      READ(13,*)(icod(I,J),I=1,IM)	   

200    continue
      CLOSE(13)

	
	OPEN(13,FILE='icodsb.dat')

      DO 205 J=1,JM
      read (13,*) ija

      READ(13,*)(icodsb(I,J),I=1,IM)	   

205    continue
      CLOSE(13)


	do i=1,im
	do j=1,jm
	dis(i,j)=0.
	qx(i,j)=0.
	qy(i,j)=0.
	zb(i,j)=0.
	zbn(i,j)=0.
	end do
	end do
	

		 open (unit=3,file='thita.dat')
		do j=1,jm
	read (3,*) ja
		do i=1,im
	read (3,*) ia,thita,He(i,j),c(i,j)
c	write (*,*) ia,thita(i,j),He(i,j),c(i,j)
		end do
		end do


		OPEN(19,FILE='bottom.dat')
	

		do j=1,jm
		do i=1,im
       read (19,*) umax(i,j),vmax(i,j),ed(i,j),Qb(i,j)
	
	dis(i,j)=Qb(i,j)*2.*(9.81*(He(i,j)**2)/8.)/per
c	if (H(i,j).lt.dhs) dis(i,j)=2.*dis(i,j)
       
	umax(i,j)=umax(i,j)/2.
	vmax(i,j)=vmax(i,j)/2.

		end do
		end do


       	write (*,*) im,jm


c		do i=2,im,2			 
c       do j=2,jm,2
c       i2=i/2
c       j2=j/2		
c	 icodsb(i2,j2)=icodsb(i,j)	    	  
c       H(i2,j2)=H(i,j)	    
c 	  He(i2,j2)=He(i,j)
c       dis(i2,j2)=dis(i,j)
c       Qb(i2,j2)=Qb(i,j)
c       umax(i2,j2)=umax(i,j)
c       vmax(i2,j2)=vmax(i,j)
c	icod(i2,j2)=icod(i,j)
c       end do
c       end do
c       im=im/2
c       jm=jm/2
c	  dx=dx*2


	do i=1,im
	do j=1,jm
	qx(i,j)=0.
	qy(i,j)=0.
	u(i,j)=0.
	v(i,j)=0.
	end do
	end do


      OPEN(13,FILE='vel.dat')


	do j=21,JM
	do i=1,IM

	read (13,*) ai,aj,U(i,j),V(i,j),ze(i,j)

	end do
	end do
	close (13)   

	do j=1,JM
	do i=1,IM
	U(i,j)=U(i,j)
c	+uwm(i,j)
c	*(1+5*qb(i,j))
	V(i,j)=V(i,j)
c	+vwm(i,j)
c	*(1+5*qb(i,j))
	end do
	end do
	

	do j=1,JM
	do i=1,IM
	hh=H(i,j)+ze(i,j)
c	if (hh.lt.dhs.and.hh.gt.dhr) hh=dhs 
	if (hh.lt..0001) hh=.0001
            
	am=(SQRT(umax(i,j)**2+vmax(i,j)**2))/omega
	if (am.gt..01) then
	f25=exp(5.213*(2.5*d50/am)**.194-6.)
	th25=.5*f25*(am*omega)**2./(1.6*9.81*d50)
	if (th25.gt..05) then
	ra=170.*sqrt(th25-0.05)*d50
		ra=2.5*d50
	fw=exp(5.213*(ra/am)**.194-6.)
	else
	ra=2.5*d50
	fw=exp(5.213*(ra/am)**.194-6.)
	end if
	fw=0.009
	
	
	if (fw.gt..05) fw=.05
	 if (fw.lt..001) fw=.001

	ut=sqrt(umax(i,j)**2+vmax(i,j)**2)
	tbx=1000*.5*fw*ut*U(i,j)
	tby=1000*.5*fw*ut*V(i,j)
	tb=sqrt(tbx**2+tby**2)

	an=0.000001
	dsr=d50*(1.6*9.81/an**2)**.3333
	if (dsr.le.4.) snt=0.24/dsr
	if (dsr.gt.4..and.dsr.le.10.) snt=0.14*dsr**(-.64)
	if (dsr.gt.10..and.dsr.le.20.) snt=0.04*dsr**(-.1)
	if (dsr.gt.20..and.dsr.le.150.) snt=0.013*dsr**0.29
	if (dsr.gt.150.) snt=0.055

	tcr=snt*(2600-1000)*9.81*d50
	
	if (tb.gt.tcr) then
c	if (tb.gt.0) then
	th=tbx/(1600*9.81*d50)
	thcr=tcr/(1600*9.81*d50)
	qbx=11.*sqrt(1.65*9.81*d50**3)*tbx/tb*(tb-tcr)**1.65/.6
	th=tby/(1600*9.81*d50)
	thcr=tcr/(1600*9.81*d50)
	qby=11.*sqrt(1.65*9.81*d50**3)*tby/tb*(tb-tcr)**1.65/.6
	else
	qbx=0.
	qby=0.
	end if


	tmaxx=1000.*.5*fw*(abs(U(i,j))+umax(i,j))
	tmaxy=1000.*.5*fw*(abs(V(i,j))+vmax(i,j))
	tmaxt=sqrt(tmaxx**2+tmaxy**2)

	
c	Haas and Hanes, 2004
	sigu=2.*umax(i,j)
	sigv=2.*vmax(i,j)
	sigmat=(SQRT(sigu**2+sigv**2))
c	sigmat=0.
	tbx=1000.*.5*fw*U(i,j)*(sigmat**2*1.16**2+U(i,j)**2)**.5
	tby=1000.*.5*fw*V(i,j)*(sigmat**2*1.16**2+V(i,j)**2)**.5
	tb=sqrt(tbx**2+tby**2)
	if (tb.gt.tcr) then
c	if (tb.gt.0) then
c	qbx=1.3*2.*U(i,j)*(tb-tcr)/1000./9.81
c	qby=1.3*2.*V(i,j)*(tb-tcr)/1000./9.81
	else
	qbx=0
	qby=0
	end if



c	if (tb.gt.tcr) then
c               .15
c	qbwx(i,j)=.5*1.3*2.*umax(i,j)*(tb-tcr)/1000./9.81
c	qbwy(i,j)=.5*1.3*2.*vmax(i,j)*(tb-tcr)/1000./9.81
c	else
c	qbwx(i,j)=0
c	qbwy(i,j)=0
c	end if 

	if (tb.gt.tcr) then
	qbwx(i,j)=.15*1.3*2.*umax(i,j)*(tb-tcr)/1000./9.81
	qbwy(i,j)=.15*1.3*2.*vmax(i,j)*(tb-tcr)/1000./9.81
	else
	qbwx(i,j)=0
	qbwy(i,j)=0
	end if 


	aPx=(h(i,j)/alo)*umax(i,j)**2/1.6/9.81/d50
	aPy=(h(i,j)/alo)*vmax(i,j)**2/1.6/9.81/d50
	aPx=(hh/alo)*umax(i,j)**2/1.6/9.81/d50
	aPy=(hh/alo)*vmax(i,j)**2/1.6/9.81/d50


	aPc=.2
	aPc=1.
	Fdx=tanh(2*(aPc-aPx)/aPx)
	Fdy=tanh(2*(aPc-aPy)/aPy)
c	Fdx=0.
c	Fdy=0.
	
c	if (Fdx.ge.0) then
c	Fdx=1.
c	else
c	Fdx=-1.
c	end if

c	if (Fdy.ge.0) then
c	Fdy=1.
c	else
c	Fdy=-1.
c	end if

	hh=h(i,j)
	if (hh.lt.dhs) hh=dhs

	epsb=0.1
	tanfi=0.6
	trog=3./8.
	aPb=(He(i,j)/gamma/hh)**4
	if (aPb.gt.1) aPb=1.
	AAS=1.2*0.5*(He(i,j)/hh)*(1-aPb)

c      qbwx(i,j)=(trog*epsb/tanfi)*fw*AAS*umax(i,j)**3
c      qbwy(i,j)=(trog*epsb/tanfi)*fw*AAS*vmax(i,j)**3
c	qbwx(i,j)=(trog*epsb/tanfi)*fw*AAS*(ut**2)*umax(i,j)
c      qbwy(i,j)=(trog*epsb/tanfi)*fw*AAS*(ut**2)*vmax(i,j)
c	Fdx=1.
c	Fdy=1.


c	if (uwm(i,j).lt.0) then
c	qbx=qbx+Fdx*qbwx(i,j)
c	else
c	qbx=qbx-Fdx*qbwx(i,j)
c	end if

c	if (vwm(i,j).lt.0) then
c	qby=qby+Fdy*qbwy(i,j)
c	else
c	qby=qby-Fdy*qbwy(i,j)
c 	end if


      thit=tb/(1600*9.81*d50)
      thf=abs(thit)
	Cbsa=0.49*thf**1.77*(d50/wf/per/fw)**1.77
	Cbsa=0.0015*exp(-0.2*dsr)*thf*exp(-4.5*tcr/tmaxt)

      ustar=sqrt(abs(tb)/1000.)

      anz=.083*ustar*hh+.025*hh*dis(i,j)**.33333
c	anz=ed(i,j)/120.

	if (anz.lt.an) anz=an
	
      Ct=Cbsa*(anz/wf)*abs(exp(-wf*hh/anz)-1.)
      qsx=Ct*U(i,j)/.6
	qsy=Ct*V(i,j)/.6

	Hee=He(I,j)
	if (Hee.lt..1*hh) Hee=.1*hh
	btaa=exp(hh/Hee)-1.
	if (btaa.lt.2.) btaa=2.
	bta=1./btaa
c	bta=.2
c     Leontyev
	Qbb=Qb(i,j)
	if (Qbb.lt..00001) Qbb=.00001
c	bta=sqrt(aksi)*exp(-2*(1./Qbb-1.))
	uc=bta*.02*Dis(i,j)/9.81/1.6/wf/.6
c	qsx=uc*U(i,j)
c	qsy=uc*V(i,j)

c	if (hh.le.3.*dhs) qbx=3.*qbx
c	if (hh.le.3.*dhs) qby=3.*qby

	qxaa(i,j)=qbx+qsx
	qyaa(i,j)=qby+qsy 

	if (hh.le.2.5*dhs) qxaa(i,j)=3.0*qxaa(i,j)
	if (hh.le.2.5*dhs) qyaa(i,j)=3.0*qyaa(i,j)

	if (abs(qxaa(i,j)).gt.qxmax) qxmax=abs(qxaa(i,j))
	if (abs(qyaa(i,j)).gt.qymax) qymax=abs(qyaa(i,j))
	
	else
	end if

	if (icodsb(I,J).eq.1) qx(i,j)=0.
	if (icodsb(I,J).eq.1) qy(i,j)=0.
	end do
	end do



c	    do j=2,jm-1
c		do i=2,im-1
c		qxa(i,j)=.5*qxaa(i,j)+.5*qxaa(i+1,j)
c		qya(i,j)=.5*qyaa(i,j)+.5*qyaa(i,j+1)
c		end do
c		end do

	do j=2,jm-1
	do i=2,im-1
	qxa(i,j)=qxaa(i,j)
	qya(i,j)=qyaa(i,j)
	end do
	end do
	

		
		do ij=1,2
	    do j=3,jm-2
		do i=3,im-2
c	qx(i,j)=qxa(i,j)
c	qy(i,j)=qya(i,j)
c
	if (icodsb(i,j).ne.1.and.icodsb(i+1,j).ne.1.and.icodsb(i-1,j).ne.1
     & .and.icodsb(i,j+1).ne.1.and.icodsb(i,j-1).ne.1.and.
     & icodsb(i+2,j).ne.1.and.icodsb(i-2,j).ne.1
     & .and.icodsb(i,j+2).ne.1.and.icodsb(i,j-2).ne.1) then
		qx(i,j)=
     &.25*qxa(i-2,j)+.25*qxa(i+2,j)+.25*qxa(i,j-2)+.25*qxa(i,j+2)
		qy(i,j)=
     &.25*qya(i-2,j)+.25*qya(i+2,j)+.25*qya(i,j-2)+.25*qya(i,j+2)
	else
	end if

		end do
		end do
	end do


		
	open (unit=17,file='q2d.dat')
        

        do i=1,im
        do j=1,jm
c	if (h(i,j).gt..01) then
        write (17,250) i*dx,j*dx,qx(i,j),qy(i,j)
        
c	else
c	end if
	end do
	end do

	open (unit=18,file='sect_q.dat')

      do j=1,jm
	qxh=qx(im/2,j)*60.*60.*24.*365.
      write (18,*) (126-j)*dx,qxh,qy(im/2,j)
	end do




c		do ij=1,0
	   
c	end do
c
		
	do j=2,jm-1
	do i=2,im-1
	eps=15.
	qxm=(qx(i,j)+qx(i+1,j))/2.
	qym=(qy(i,j)+qy(i,j+1))/2.
	qt=sqrt(qxm**2+qym**2)
	sx=(h(i-1,j)-h(i+1,j))/2./dx
	qxr(i,j)=qx(i,j)-eps*qt*sx
	sy=(h(i,j-1)-h(i,j+1))/2./dx
	qyr(i,j)=qy(i,j)-eps*qt*sy
	end do
	end do


		do i=2,im-2
	do j=3,jm-2

	eps=60.
	aqx=.5*(abs(qx(i-1,j))+abs(qx(i+1,j)))
     !	+.5*(abs(qbwx(i-1,j))+abs(qbwx(i+1,j)))
	aqy=.5*(abs(qy(i,j-1))+abs(qy(i,j+1)))
     !	+.5*(abs(qbwy(i,j-1))+abs(qbwy(i,j+1)))

c	aqx=.5*(abs(qx(i-1,j))+abs(qx(i+1,j)))
c     	aqy=.5*(abs(qy(i,j-1))+abs(qy(i,j+1)))
	aqt(i,j)=eps*sqrt(aqx**2+aqy**2)
	aqtmax=eps*sqrt(qxmax**2+qymax**2)
	
	end do
	end do


	do ija=1,5
		do i=2,im-2
	do j=3,jm-2

	aqt(i,j)=
     &.25*aqt(i-1,j)+.25*aqt(i+1,j)+.25*aqt(i,j-1)+.25*aqt(i,j+1)

	end do
	end do
	end do


		do ij=1,iend



			write(*,*) ij		   
 	do 100 i=2,im-2
	do 100 j=3,jm-2

		if (icodsb(I,J).eq.1) qx(i,j)=0.
	if (icodsb(I,J).eq.1) qy(i,j)=0.

	 	if (icodsb(i,j).eq.1) then
	 zbn(i,j)=0.
	 goto 100		    
	 else
	 end if

	if (icodsb(i,j).eq.0.and.icodsb(i+1,j).eq.1) then
	zbn(i,j)=zbn(i-1,j)
	goto 100
	else
	end if
	if (icodsb(i,j).eq.0.and.icodsb(i-1,j).eq.1) then
	zbn(i,j)=zbn(i+1,j)
	goto 100
	else
	end if
	if (icodsb(i,j).eq.0.and.icodsb(i,j+1).eq.1) then
	zbn(i,j)=zbn(i,j-1)
	goto 100
	else
	end if
	if (icodsb(i,j).eq.0.and.icodsb(i,j-1).eq.1) then
	zbn(i,j)=zbn(i,j+1)
	goto 100
	else
	end if	 

	zbxx=aqt(i,j)*(zb(i+1,j)-2*zb(i,j)+zb(i-1,j))/dx**2	
	zbyy=aqt(i,j)*(zb(i,j+1)-2*zb(i,j)+zb(i,j-1))/dx**2
	zbx=(zb(i+1,j)-zb(i-1,j))/2./dx
	zqx=eps*(abs(qx(i+1,j))-abs(qx(i-1,j)))*zbx/dx/2.
	zby=(zb(i,j+1)-zb(i,j-1))/2./dx
	zqy=eps*(abs(qy(i,j+1))-abs(qy(i,j-1)))*zby/dx/2.
c	zbxx=0.
c	zbyy=0.
c	zqx=0.
c	zqy=0.
c	qxx=(qxr(i+1,j)-qxr(i,j))/dx
c	qyy=(qyr(i,j+1)-qyr(i,j))/dx
c	zbbi=zb(i,j)
c	zbn(i,j)=zbbi-dt*(qxx+qyy)
	
c	qxx=(qx(i+1,j)-qx(i-1,j))/dx/2.
c	qyy=(qy(i,j+1)-qy(i,j-1))/dx/2.
	qxx=(qx(i+2,j)-qx(i-1,j))/dx/4.
	qyy=(qy(i,j+2)-qy(i,j-1))/dx/4.
	zbbi=zb(i,j)
	zbbi=.998*zb(i,j)+
     &.0005*zb(i-1,j)+.0005*zb(i+1,j)+.0005*zb(i,j-1)
     & +.0005*zb(i,j+1)
	zbbi=zb(i,j)
	zbn(i,j)=zbbi-dt*(qxx+qyy)+dt*(zbxx+zbyy)
c	+dt*(zqx+zqy)

c	if (zb(i,j).gt.0.) then
c	sumacr=sumacr+zb(i,j)
c	else	do i=2,im-1
		
	
c	sumer=sumer+zb(i,j)
c	end if

	  
100     continue     


		do i=2,im-1
	do  j=2,jm-1


	 	if (icodsb(i,j).eq.1) then
	 zbn(i,j)=0.
	 goto 105		    
	 else
	 end if

	if (icodsb(i,j).eq.0.and.icodsb(i+1,j).eq.1) then
	zbn(i,j)=zbn(i-1,j)
	goto 105
	else
	end if
	if (icodsb(i,j).eq.0.and.icodsb(i-1,j).eq.1) then
	zbn(i,j)=zbn(i+1,j)
	goto 105
	else
	end if
	if (icodsb(i,j).eq.0.and.icodsb(i,j+1).eq.1) then
	zbn(i,j)=zbn(i,j-1)
	goto 105
	else
	end if
	if (icodsb(i,j).eq.0.and.icodsb(i,j-1).eq.1) then
	zbn(i,j)=zbn(i,j+1)
	goto 105
	else
	end if

105   continue
	end do
	end do	 


	do i=1,im
	do j=1,jm
	zb(i,j)=zbn(i,j)
	end do
	
	end do

	   
	end do  
	


c	do i=1,im
c	do j=1,jm
c	ii=i*2
c	jj=j*2
c	zbn(ii-1,jj-1)=zb(i,j)
c	zbn(ii,jj-1)=zb(i,j)
c	zbn(ii-1,jj)=zb(i,j)
c	zbn(ii,jj)=zb(i,j)
c	end do
c	end do
c	im=im*2
c	jm=jm*2
c	dx=dx/2. 


	do i=1,im
	do j=1,jm
	zsm(i,j)=zbn(i,j)
	end do
	end do

	 do j=3,jm-2
		do i=3,im-2
	if (icodsb(i,j).ne.1.and.icodsb(i+1,j).ne.1.and.icodsb(i-1,j).ne.1
     & .and.icodsb(i,j+1).ne.1.and.icodsb(i,j-1).ne.1.and.
     & icodsb(i+2,j).ne.1.and.icodsb(i-2,j).ne.1
     & .and.icodsb(i,j+2).ne.1.and.icodsb(i,j-2).ne.1) then
	zbn(i,j)=.25*zsm(i-1,j)+
     &.25*zsm(i+1,j)+.25*zsm(i,j-1)+.25*zsm(i,j+1)
	 else
	end if
		end do
		end do


	do ijk=1,1
	
	do j=2,jm-1
	do i=2,im-1

	dzsm(i,j)=zsm(i,j)-zbn(i,j)
	if (icodsb(i,j).ne.1.and.icodsb(i+1,j).ne.1.and.icodsb(i-1,j).ne.1
     & .and.icodsb(i,j+1).ne.1.and.icodsb(i,j-1).ne.1.and.
     & icodsb(i+2,j).ne.1.and.icodsb(i-2,j).ne.1
     & .and.icodsb(i,j+2).ne.1.and.icodsb(i,j-2).ne.1) then
	dzsmn(i,j)=.25*dzsm(i-1,j)+
     &.25*dzsm(i+1,j)+.25*dzsm(i,j-1)+.25*dzsm(i,j+1)
	 else
	end if
	zsm(i,j)=zbn(i,j)+dzsmn(i,j)

	end do
	end do

	end do
			
	
	do j=2,jm-1
	do i=2,im-1
	zbn(i,j)=zsm(i,j)
	end do
	end do


	 open (unit=21,file='newbed.dat')
	

  	  do i=1,im
	  do j=1,jm
c	  if (H(i,j).gt..01) then
	  Hn(i,j)=Hold(i,j)-zbn(i,j)
c	  else
c	  Hn=H(i,j)
c	  end if
	  write (21,155) i*dx,j*dx,Hn(i,j),Hold(i,j),zbn(i,j)
	  end do
	  end do



	OPEN(12,FILE='depth.dat')
	write (12,*) im,jm

      DO 201 J=1,JM
      write (12,*) j

      write(12,135)(Hn(I,J),I=1,IM)	   

201    continue
      CLOSE(12)


250   format(4f18.6)
155	  format(5f15.6)

15      format (8f9.4)
135      format (5f15.6)

	 END

